
% This programme is written by Dr. Rajib Kumar Bhattacharjya of Department
% of Civil Engineering, Indian Institute of technology for demonstrating
% simple Particle Swarm Optimization Algorithm

clear all;

numPart = 20; % number of particles
numVar =2; % Number of variables
fileName = 'fitness';
w = 0.5; % Inertia weight
C1 = 2; % learning factor for local search
C2 = 2; % learning factor for local search
maxGen =500; % Maximum generation
lb = 0; % Lower bound of the variables
ub = 5; % Upper bound of the variables

X = lb + (ub-lb)*rand(numPart,numVar); % initialize X
V = lb + (ub-lb)*rand(numPart,numVar); % initialize V

for i=1:numPart
%     f(i)=fitness(X(i,:));
    f(i)=feval(fileName,X(i,:));
end

X = [V X f'];
Y = sortrows(X,2*numVar+1);
pbest = Y;
gbest = Y(1,:);

for gen=1:maxGen % generation loop
    
    for part=1:numPart % Particle loop
        for dim=1:numVar % Variable loop
            V(part,dim)=w*V(part,dim)+C1*rand(1,1)*(pbest(part,numVar+dim)-X(part,numVar+dim))+C2*rand(1,1)*(gbest(numVar+dim)-X(part,numVar+dim));
            X(part,numVar+dim)=X(part,numVar+dim)+V(part,dim);
        end
%         fnew = fitness(X(part,numVar+1:numVar+dim));
        fnew = feval(fileName,X(part,numVar+1:numVar+dim));
        X(part,2*numVar+1)=fnew;
        if (fnew<X(part,2*numVar+1))
            pbest(part,:)=X(part,:);
        end
    end
    Y = sortrows(X,2*numVar+1);
    if (Y(1,2*numVar+1)<gbest(2*numVar+1))
        gbest=Y(1,:);
    end
    disp(['Generation    ', num2str(gen)]);
    disp(['Best Value  ', num2str(gbest(numVar+1:2*numVar+1))]);
end









